%define release_name ARM64
%define fedora_release_name Rawhide
%define dist_version 21
%define bug_version Rawhide

Summary:	ARM64 release files
Name:		arm64-release
Version:	1.2
Release:	0.3
License:	GPLv2
Group:		System Environment/Base
URL:		http://dmarlin.fedorapeople.org/fedora-arm/aarch64
Source:		%{name}-%{version}.tar.bz2
Patch0:		%{name}-%{version}.patch
Obsoletes:	redhat-release
Provides:	redhat-release
Obsoletes:	fedora-release
Provides:	fedora-release
Provides:	system-release
Provides:	system-release(%{version})
Obsoletes:	fedora-release-rawhide < %{dist_version}-%{release}
BuildArch:	noarch

%description
ARM64 release files such as yum configs and various /etc/ files that
define the release.  This release is based on Fedora, but is a remix for 
the 64-bit ARM (aarch64).


%prep
%setup -q
sed -i 's|@@VERSION@@|%{dist_version}|g' README.txt
%patch0 -p1

%build

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT/etc
echo "ARM64 release %{version} (%{release_name})" > $RPM_BUILD_ROOT/etc/arm64-release
#echo -e "\t\tbased on Fedora %{dist_version} (%{fedora_release_name})" >> $RPM_BUILD_ROOT/etc/arm64-release
echo "cpe:/o:fedoraproject:fedora:%{dist_version}" > $RPM_BUILD_ROOT/etc/system-release-cpe
cp -p $RPM_BUILD_ROOT/etc/arm64-release $RPM_BUILD_ROOT/etc/issue
echo "Kernel \r on an \m (\l)" >> $RPM_BUILD_ROOT/etc/issue
cp -p $RPM_BUILD_ROOT/etc/issue $RPM_BUILD_ROOT/etc/issue.net
echo >> $RPM_BUILD_ROOT/etc/issue
ln -s arm64-release $RPM_BUILD_ROOT/etc/redhat-release
ln -s arm64-release $RPM_BUILD_ROOT/etc/system-release

cat << EOF >>$RPM_BUILD_ROOT/etc/os-release
NAME=ARM64
VERSION="%{version} (%{release_name})"
ID=arm64
VERSION_ID=%{version}
PRETTY_NAME="ARM64 %{version} (%{release_name})"
ANSI_COLOR="0;34"
CPE_NAME="cpe:/o:fedoraproject:fedora:%{dist_version}"
HOME_URL="https://fedoraproject.org/"
BUG_REPORT_URL="https://bugzilla.redhat.com/"
REDHAT_BUGZILLA_PRODUCT="Fedora"
REDHAT_BUGZILLA_PRODUCT_VERSION=%{bug_version}
REDHAT_SUPPORT_PRODUCT="Fedora"
REDHAT_SUPPORT_PRODUCT_VERSION=%{bug_version}
EOF

# Install the keys
install -d -m 755 $RPM_BUILD_ROOT/etc/pki/rpm-gpg
install -m 644 RPM-GPG-KEY* $RPM_BUILD_ROOT/etc/pki/rpm-gpg/

# Link the primary/secondary keys to arch files, according to archmap.
# Ex: if there's a key named RPM-GPG-KEY-fedora-19-primary, and archmap
#     says "fedora-19-primary: i386 x86_64",
#     RPM-GPG-KEY-fedora-19-{i386,x86_64} will be symlinked to that key.
pushd $RPM_BUILD_ROOT/etc/pki/rpm-gpg/
for keyfile in RPM-GPG-KEY*; do
    key=${keyfile#RPM-GPG-KEY-} # e.g. 'fedora-20-primary'
    arches=$(sed -ne "s/^${key}://p" $RPM_BUILD_DIR/%{name}-%{version}/archmap) \
        || echo "WARNING: no archmap entry for $key"
    for arch in $arches; do
        # replace last part with $arch (fedora-20-primary -> fedora-20-$arch)
        ln -s $keyfile ${keyfile%%-*}-$arch # NOTE: RPM replaces %% with %
    done
done
# and add symlink for compat generic location
ln -s RPM-GPG-KEY-fedora-%{dist_version}-primary RPM-GPG-KEY-%{dist_version}-fedora
popd

install -d -m 755 $RPM_BUILD_ROOT/etc/yum.repos.d
for file in *.repo ; do
  install -m 644 $file $RPM_BUILD_ROOT/etc/yum.repos.d
done

# Set up the dist tag macros
install -d -m 755 $RPM_BUILD_ROOT%{_rpmconfigdir}/macros.d
cat >> $RPM_BUILD_ROOT%{_rpmconfigdir}/macros.d/macros.dist << EOF
# dist macros.

%%fedora	%{dist_version}
%%dist		.fc%{dist_version}
%%fc%{dist_version}		1
EOF

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%doc GPL README.txt
%config %attr(0644,root,root) /etc/os-release
%config %attr(0644,root,root) /etc/arm64-release
/etc/redhat-release
/etc/system-release
%config %attr(0644,root,root) /etc/system-release-cpe
%dir /etc/yum.repos.d
%config(noreplace) /etc/yum.repos.d/arm64.repo
%config(noreplace) /etc/yum.repos.d/fedora-rawhide.repo
%config(noreplace) %attr(0644,root,root) /etc/issue
%config(noreplace) %attr(0644,root,root) /etc/issue.net
%attr(0644,root,root) %{_rpmconfigdir}/macros.d/macros.dist
%dir /etc/pki/rpm-gpg
/etc/pki/rpm-gpg/*


%changelog
* Fri Jun  6 2014 d.marlin <dmarlin@redhat.com>
- Exclude generic-release, which conflicts with this.

* Wed May 28 2014 d.marlin <dmarlin@redhat.com>
- Add a provides for unversioned system-release.

* Sun Mar 16 2014 d.marlin <dmarlin@redhat.com>
- Update to base on Fedora 21 - Rawhide

* Wed Aug 15 2013 d.marlin <dmarlin@redhat.com>
- Initial ARM64 release package.

